<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: circular_buffer_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_d81890b6f633414461eaaa6daa410a59.html">sliding_buffer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">circular_buffer_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2012  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_CIRCULAR_BuFFER_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_CIRCULAR_BuFFER_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../serialize.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        &gt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keyword">class </span>circular_buffer</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">typedef</span> <a class="code" href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">default_memory_manager</a> mem_manager_type;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">typedef</span> T value_type;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">typedef</span> T type;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        circular_buffer(</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        );</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        );</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        T&amp; operator[] ( </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">const</span> T&amp; operator[] ( </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordtype">void</span> resize(</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> new_size</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        ); </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keywordtype">void</span> assign(</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> new_size, </div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            <span class="keyword">const</span> T&amp; value</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        ); </div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> size(</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        T&amp; front(</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        );</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keyword">const</span> T&amp; front(</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        T&amp; back(</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        );</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keyword">const</span> T&amp; back(</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordtype">void</span> push_front(</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            <span class="keyword">const</span> T&amp; value</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        );</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        <span class="keywordtype">void</span> push_back(</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            <span class="keyword">const</span> T&amp; value</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        );</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            circular_buffer&amp; item</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        );</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    };</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160; </div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        &gt;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        circular_buffer&lt;T&gt;&amp; a, </div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        circular_buffer&lt;T&gt;&amp; b </div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    ) { a.swap(b); }   </div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        &gt;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keyword">const</span> circular_buffer&lt;T&gt;&amp; item, </div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        std::ostream&amp; out </div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    );   </div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        &gt;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        circular_buffer&lt;T&gt;&amp; item, </div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        std::istream&amp; in</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    );   </div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160; </div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        &gt;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keyword">const</span> matrix_exp mat (</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <span class="keyword">const</span> circular_buffer&lt;T&gt;&amp; m </div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    );</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160; </div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;}</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160; </div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="preprocessor">#endif // DLIB_CIRCULAR_BuFFER_ABSTRACT_Hh_</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160; </div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html_ae8aaef18fce6452263f46535116308ca"><div class="ttname"><a href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">dlib::default_memory_manager</a></div><div class="ttdeci">memory_manager_stateless_kernel_1&lt; char &gt; default_memory_manager</div><div class="ttdef"><b>Definition:</b> algs.h:129</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
